/* $Id$ */

/**
 * @file
 * Location geo phase1 textfield sync.
 */

/*global jQuery, Drupal, GEvent, GLatLng, GMarker */

Drupal.gmap.addHandler('gmap', function (elem) {
  var obj = this;

  obj.bind("ready", function () {
    // Reset, right here, right now, because we need to check ml_poly.
    obj.change('ml_reset', -1);
    // Zoom the map to the local area if we have a proper polygon.
    // @@@ Do we want this?
    if (obj.ml_poly.getVertexCount() > 2) {
      obj.map.setCenter(obj.ml_poly.getBounds().getCenter(), obj.map.getBoundsZoomLevel(obj.ml_poly.getBounds()));
    }
  });
  
  obj.bind("ml_reset_reattach", function() {
    // Dynamically flip editing on and off because it looks nice.
    GEvent.addListener(obj.ml_poly, 'mouseover', function() {
      this.enableEditing();
    });
    GEvent.addListener(obj.ml_poly, 'mouseout', function() {
      this.disableEditing();
    });
    // Disable / enable 
    GEvent.addListener(obj.map, 'zoomend', function(oldLevel, newLevel) {
      // 7: About the size of Kansas.
      if (newLevel >= 7) {
        jQuery('#ml_surround_button').removeClass('gmap-custom-control-button-disabled');
      }
      else {
        jQuery('#ml_surround_button').addClass('gmap-custom-control-button-disabled');
      }
    });
      
    // Resync when a change is detected.
    GEvent.addListener(obj.ml_poly, 'lineupdated', function() {
      obj.change('ml_resync', -1);
    });
    // "Delete vertex on click" behavior.
    GEvent.addListener(obj.ml_poly, 'click', function(latlng, index) {
      if (typeof index === "number") {
        if (obj.ml_poly.getVertexCount() > 3) {
          // Delete vertex on click.
          obj.ml_poly.deleteVertex(index);
        }
      }
    });
  });
});

function rb() {};
rb.prototype = new GControl();

Drupal.gmap.addHandler('locpick_sync',function(elem) {
  var obj = this;

  var rb = function() {};
  rb.prototype = new GControl();
  rb.prototype.initialize = function(map) {
    obj.surrounding_polys = [];
    var mapContainer = jQuery('#' + map.getContainer().id);
    mapContainer.append('<div id="ml_editing_buttons" class="gmnoprint"></div>');
    var buttonContainer = document.getElementById('ml_editing_buttons');
    jQuery('#ml_editing_buttons').append('<div id="ml_redraw_button" title="Clear the section and start over." class="gmap-custom-control-button gmnoprint" style="left: 0em;"><div>Redraw</div></div>');
    jQuery('#ml_editing_buttons').append('<div id="ml_surround_button" title="Display any existing sections that may overlap your section. Click this button if you move or zoom the map." class="gmap-custom-control-button gmnoprint gmap-custom-control-button-disabled" style="left: 5.1em;"><div>Nearby</div></div>');
    jQuery('#ml_editing_buttons').append('<div id="ml_clip_button" title="Adjust your section to make sure it doesn\'t overlap existing sections." class="gmap-custom-control-button gmnoprint" style="left: 10.2em;"><div>Clip</div></div>');
    var mlRedraw = document.getElementById('ml_redraw_button');
    var mlSurround = document.getElementById('ml_surround_button');
    var mlClip = document.getElementById('ml_clip_button');
    GEvent.addDomListener(mlRedraw, 'click', function(e) {
      obj.deferChange('ml_reset', -1);
    });
    GEvent.addDomListener(mlSurround, 'click', function() {
      if (jQuery(mlSurround).hasClass('gmap-custom-control-button-disabled')) {
        // Disable Nearby if you aren't zoomed in far enough.
        return;
      }
      var bounds = obj.map.getBounds();
      var u = "/phase1_surroundings_callback/";
      u = u + bounds.getNorthEast().lat() + "," + bounds.getNorthEast().lng() + "," + bounds.getSouthWest().lat() + "," + bounds.getSouthWest().lng();
      if (Drupal.settings.phase1_section_nid_hack) {
        u = u + "/" + Drupal.settings.phase1_section_nid_hack;
      }
      else {
        u = u + "/0";
      }
      jQuery.getJSON(u, function(data, status) {
        var re = /([0-9.\-]+) ([0-9.\-]+)/g;
        var st;
        var string;
        var match;
        var points;
        var tmppoly;
        jQuery.each(obj.surrounding_polys, function (i, poly) {
          obj.map.removeOverlay(poly);
        });
        obj.surrounding_polys = [];
        jQuery.each(data.items, function(i, poly) {
          st = new String(poly.wkt);
          points = [];
          while ((match = re.exec(st))) {
            points.push(new GLatLng(Number(match[2]),Number(match[1])));
          }
          tmppoly = new GPolygon(points, '#000000', 2, 0.5, '#ff0000', 0.25);
          obj.map.addOverlay(tmppoly); // @@@
          obj.surrounding_polys.push(tmppoly);
        });
      });
    });
    GEvent.addDomListener(mlClip, 'click', function() {
      var u = "/geom/clip/section";
      if (Drupal.settings.phase1_section_nid_hack) {
        u = u + "/" + Drupal.settings.phase1_section_nid_hack;
      }
      else {
        u = u + "/0";
      }
      jQuery.post(
        u,
        {'current_geom': obj.ml_mirror},
        function (data, status, req) {
          obj.change("ml_reset", -1, data.wkt);
          jQuery.each(data.messages, function() {
            // @@@ Better way to show these?
            alert(this);
          });
        },
        'json');
    });
/*
    $(buttonContainer).click(function(e) {
      e.stopPropagation();
      e.preventDefault();
      obj.deferChange('ml_reset', -1);
      return false;
    });
*/
    return buttonContainer;
  };
  rb.prototype.getDefaultPosition = function() {
    return new GControlPosition(G_ANCHOR_TOP_LEFT, new GSize(47, 7));
  };
  
  obj.bind("init", function() {

/*
    $(elem).parents('form').submit(function (e) {
      
      alert('Test submit');
    });
*/

    obj.map.addControl(new rb(obj.map));
  });

  obj.bind("ml_reset", function(wkt) {
    if (obj.ml_poly) {
      obj.ml_poly.disableEditing();
      obj.map.removeOverlay(obj.ml_poly);
      GEvent.clearInstanceListeners(obj.ml_poly);
      obj.ml_poly = null;
      jQuery(elem).val("");
      obj.ml_mirror = "";
    }
    if (wkt) {
      jQuery(elem).val(wkt);
      obj.ml_mirror = wkt;
    }
    if (elem.value != '') {
      var re = /([0-9.\-]+) ([0-9.\-]+)/g;
      var st = new String(elem.value);
      var match;
      var points = [];
      while ((match = re.exec(st))) {
        points.push(new GLatLng(Number(match[2]),Number(match[1])));
      }
      if (points.length < 3) {
        // Polygons with less than 3 points are definately invalid.
        points = [];
        elem.value = '';
        obj.ml_mirror = '';
      }
      // Auto-close polygon.
      else {
        if (points[0].lat() != points[points.length - 1].lat() || points[0].lng() != points[points.length - 1].lng()) {
          points.push(points[0]);
        }
      }
    }
    else {
      points = [];
    }
    obj.ml_poly = new GPolygon(points, '#000000', 2, 0.5, '#009900', 0.5);
    obj.map.addOverlay(obj.ml_poly);
    if (points.length > 0) {
      // Give the polygon editor a kick in the pants so we don't have lag
      // the first mouseover.
      obj.ml_poly.enableEditing();
      obj.ml_poly.disableEditing();
      obj.change('ml_resync', -1);
    }
    else {
      obj.ml_poly.enableDrawing();
    }
    obj.change("ml_reset_reattach", -1);
  });

  var binding = obj.bind("ml_resync", function() {
    var b = "POLYGON((";
    var n = [];
    var c = obj.ml_poly.getVertexCount();
    var p;
    for (var i = 0; i < c; i++) {
      p = obj.ml_poly.getVertex(i);
      n.push("" + p.lng() + " " + p.lat());
    }
    // Keep polygon closed at all times.
    // This prevents issues with processing a section while editing it.
    if (n.length > 2) {
      if (n[0] != n[n.length - 1]) {
        n.push(n[0]);
      }
    }
    b = b + n.join(",") + "))";
    jQuery(elem).val(b);
    obj.ml_mirror = b;
  });
});
